
This page contains a list of what you can do with Libra, with the links to corresponding examples

_______

# Libra usage: By the task required


## 1. Reading and visualizing MD trajectories

### 1.1. How to visualize QE xml MD
* [Visualization of CO2 trajectory](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)

### 1.2. How to compute probability distribution function
* [How to compute velocity probability distribution function](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)
* [How to compute atom coordinate fluctuations](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)


## 2. Working with atomic lattices

### 2.1. How to determine connectivity automatically 
* [How to autoconnect atoms in a periodic lattice](../notebooks/Example4_md/Example1_lattice/Lattice_MD.ipynb)


_______

# Libra usage: By the module/functions used

## 1. libra_core

### 1.1. DATA

#### 1.1.1. Calculate_Estimators

* [Example 1](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)

#### 1.1.2. Calculate_MiniMax

* [Example 1](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)

#### 1.1.3. Calculate_Distribution

* [Example 1](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)



## 2. libra_py

### 2.1. QE_methods

#### 2.1.1. read_md_data

* [Example 1](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)

#### 2.1.2. read_md_data_cell

* [Example 1](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)


### 2.2. build

#### 2.2.1. make_xyz_mat

* [Example 1](../notebooks/Example4_md/Example2_atomistic/MD.ipynb)

#### 2.2.2. add_atom_to_system

* [Example 1](../notebooks/Example4_md/Example1_lattice/Lattice_MD.ipynb)
